"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var vue_property_decorator_1 = require("vue-property-decorator");
var scenejs_1 = require("scenejs");
var SceneItemInterface = /*#__PURE__*/ (function (_super) {
    __extends(SceneItemInterface, _super);
    function SceneItemInterface() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    SceneItemInterface.prototype.setTime = function (time) {
        this.item.setTime(time);
    };
    SceneItemInterface.prototype.getTime = function () {
        return this.item.getTime();
    };
    SceneItemInterface.prototype.play = function () {
        this.css !== false ? this.item.playCSS() : this.item.play();
    };
    SceneItemInterface.prototype.pause = function () {
        this.item.pause();
    };
    SceneItemInterface.prototype.getItem = function () {
        return this.item;
    };
    SceneItemInterface.prototype.getDuration = function () {
        return this.item.getDuration();
    };
    SceneItemInterface.prototype.init = function () {
        var _this = this;
        var item = this.item;
        var sceneOptions = {};
        scenejs_1.OPTIONS.forEach(function (name) {
            sceneOptions[name] = _this.$props[name];
        });
        // console.log(this.item, this.$props, sceneOptions);
        item.setOptions(sceneOptions);
        scenejs_1.EVENTS.forEach(function (name) {
            item.on(name, function (e) {
                _this.$emit(name, e);
            });
        });
        if (this.autoplay !== false) {
            this.play();
        }
        else if (this.time !== -1) {
            this.setTime(this.time);
        }
    };
    SceneItemInterface.prototype.updated = function () {
        if (this.time !== -1 && (this.autoplay === false || this.item.getPlayState() === 'paused')) {
            this.item.setTime(this.time);
        }
    };
    SceneItemInterface.prototype.beforeDestroy = function () {
        this.item.off();
    };
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", Object)
    ], SceneItemInterface.prototype, "from", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", Object)
    ], SceneItemInterface.prototype, "to", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", Object)
    ], SceneItemInterface.prototype, "keyframes", void 0);
    __decorate([
        vue_property_decorator_1.Prop({ default: false }),
        __metadata("design:type", Boolean)
    ], SceneItemInterface.prototype, "css", void 0);
    __decorate([
        vue_property_decorator_1.Prop({ default: false }),
        __metadata("design:type", Boolean)
    ], SceneItemInterface.prototype, "autoplay", void 0);
    __decorate([
        vue_property_decorator_1.Prop({ default: -1 }),
        __metadata("design:type", Object)
    ], SceneItemInterface.prototype, "time", void 0);
    __decorate([
        vue_property_decorator_1.Prop({ default: 0 }),
        __metadata("design:type", Object)
    ], SceneItemInterface.prototype, "easing", void 0);
    __decorate([
        vue_property_decorator_1.Prop({ default: 'forwards' }),
        __metadata("design:type", String)
    ], SceneItemInterface.prototype, "fillMode", void 0);
    __decorate([
        vue_property_decorator_1.Prop({ default: 'normal' }),
        __metadata("design:type", String)
    ], SceneItemInterface.prototype, "direction", void 0);
    __decorate([
        vue_property_decorator_1.Prop({ default: 1 }),
        __metadata("design:type", Object)
    ], SceneItemInterface.prototype, "iterationCount", void 0);
    __decorate([
        vue_property_decorator_1.Prop({ default: 0 }),
        __metadata("design:type", Number)
    ], SceneItemInterface.prototype, "delay", void 0);
    __decorate([
        vue_property_decorator_1.Prop({ default: 0 }),
        __metadata("design:type", Number)
    ], SceneItemInterface.prototype, "duration", void 0);
    __decorate([
        vue_property_decorator_1.Prop({ default: 1 }),
        __metadata("design:type", Number)
    ], SceneItemInterface.prototype, "playSpeed", void 0);
    SceneItemInterface = __decorate([
        vue_property_decorator_1.Component
    ], SceneItemInterface);
    return SceneItemInterface;
}(vue_property_decorator_1.Vue));
exports.SceneItemInterface = SceneItemInterface;
//# sourceMappingURL=SceneItemInterface.js.map